local c;
local player = Var "Player";

local JudgeCmds = {
	TapNoteScore_W1 = THEME:GetMetric( "Judgment", "JudgmentW1Command" );
	TapNoteScore_W2 = THEME:GetMetric( "Judgment", "JudgmentW2Command" );
	TapNoteScore_W3 = THEME:GetMetric( "Judgment", "JudgmentW3Command" );
	TapNoteScore_W4 = THEME:GetMetric( "Judgment", "JudgmentW4Command" );
	TapNoteScore_W5 = THEME:GetMetric( "Judgment", "JudgmentW5Command" );
	TapNoteScore_Miss = THEME:GetMetric( "Judgment", "JudgmentMissCommand" );
};

local TNSFrames = {
	TapNoteScore_W1 = 0;
	TapNoteScore_W2 = 1;
	TapNoteScore_W3 = 2;
	TapNoteScore_W4 = 3;
	TapNoteScore_W5 = 4;
	TapNoteScore_Miss = 5;
};

local t = Def.ActorFrame {
	InitCommand=cmd(fov,90);
	
	LoadActor( HDActor("judgments") ) .. {
		Name="JudgmentNormal";
		InitCommand=cmd(pause;visible,false;);
		ResetCommand=cmd(finishtweening;x,0;y,0;stopeffect;visible,false);
	};
	LoadActor( HDActor("offset judgments") ) .. {
		Name="JudgmentWithOffsets";
		InitCommand=cmd(pause;visible,false;);
		ResetCommand=cmd(finishtweening;x,0;y,0;stopeffect;visible,false);
	};
	InitCommand = function(self)
		c = self:GetChildren();
	end;

	JudgmentMessageCommand=function(self, param)
		if param.Player ~= player then return end;
		if not param.TapNoteScore then return end;

		local judgmentSet;
		--[[
		if x then
			judgmentSet = c.JudgmentWithOffsets;
		else
			judgmentSet = c.JudgmentNormal;
		end;
		--]]

		-- frame check; actually relevant now.
		local iNumStates = c.JudgmentNormal:GetNumStates();
		local iFrame = TNSFrames[param.TapNoteScore];
		if not iFrame then return end
		if iNumStates == 12 then
			iFrame = iFrame * 2;
			if not param.Early then
				iFrame = iFrame + 1;
			end
		end
		self:playcommand("Reset");

		-- begin commands
		c.JudgmentNormal:visible( true );
		c.JudgmentNormal:setstate( iFrame );
		
		-- between -0.01 and 0.01 = rad
		local iOffset = param.TapNoteOffset;
		if iFrame == 0 and iOffset then
			if ( iOffset > -0.01 and iOffset < 0.01 ) then
				c.JudgmentNormal:glowshift();
				c.JudgmentNormal:effectcolor1( color("1,1,1,0") );
				c.JudgmentNormal:effectcolor2( color("1,1,1,0.35") );
				c.JudgmentNormal:effectperiod( 0.01 );
			end;
		end;
		
		c.JudgmentNormal:diffusealpha(1);
		c.JudgmentNormal:rotationx(-45);
		c.JudgmentNormal:rotationy(player == PLAYER_1 and -10 or 10)
		c.JudgmentNormal:rotationz(player == PLAYER_1 and -3 or 3);
		
		c.JudgmentNormal:linear(0.1);
		
		c.JudgmentNormal:rotationx(player == PLAYER_1 and -4.5 or 4.5);
		c.JudgmentNormal:rotationy(0);
		(cmd(sleep,0.8;linear,0.1;rotationx,0;rotationz,0;diffusealpha,0))(c.JudgmentNormal);
		--JudgeCmds[param.TapNoteScore](c.JudgmentNormal);
	end;
};

return t;
